from Bio import SeqIO

amr_genes = list(SeqIO.parse("CARD_AMR_v3.0.8_curated_Aug2020.fasta", "fasta"))
plas_reps = list(SeqIO.parse("PlasmidFinder_inclZ66.fasta", "fasta"))

wanted_genes = ["326__Cat_Phe__catA1__2229", "390__Dfr_Tmt__dfrA7__2390", "338__Sul_Sul__sul1__2283", "391__StrA_AGly__strA.v1__2409", "392__StrB_AGly__strB.v1__2410", "338__Sul_Sul__sul2__2284", "282__MphA_MLS__mphA__2174", "143__TEM_Bla__TEM-1__1667", "79__CTX-M_Bla__CTX-M-15__530", "178__QnrS_Flq__qnrS1__2006", "267__Erm_MLS__ermB.v2__2137", "390__Dfr_Tmt__dfrA5__2387", "390__Dfr_Tmt__dfrA15.v2__2365", "368__TetA_Tet__tetA.v2__2318", "369__TetB_Tet__tetB.v2__2325"]

wanted_plas_reps = {"125__FIAHI1_HI1__FIAHI1_1_HI1_AF250878__80": "IncFIAHI1", "122__HI1A___HI1A_1__AF250878__74": "IncHI1A", "101__HI1BR27_R27__HI1BR27_1_R27_AF250878__142": "IncHI1BR27", "72__Y_1__Y_1__K02380__313": "IncY", "fljB_z66":"z66"}

probe_seqs = []

for amr_gene in amr_genes:
    if amr_gene.id in wanted_genes:
        # then select this gene to make a probe from
        gene_name = amr_gene.id.split('__')[2]
        # remove the .vX from the gene name
        if '.v' in gene_name:
            gene_name = gene_name.split('.v')[0]
        if '-' in gene_name:
            gene_name = gene_name.replace('-', '')
        # create the mykrobe probe header
        gene_header = gene_name + '?name=' + gene_name + '&version=1'
        amr_probe_record = amr_gene
        amr_probe_record.id = gene_header
        amr_probe_record.description = ''
        probe_seqs.append(amr_probe_record)
for plas_rep in plas_reps:
    if plas_rep.id in wanted_plas_reps.keys():
        # select this rep and make a probe
        probe_name = wanted_plas_reps[plas_rep.id]
        probe_header = probe_name + '?name=' + probe_name + '&version=1'
        plas_probe_record = plas_rep
        plas_probe_record.id = probe_header
        plas_probe_record.description = ''
        probe_seqs.append(plas_probe_record)

#write out
SeqIO.write(probe_seqs, 'typhi.amr.plas.presAbs.20210324.fa', 'fasta')
